/* pocl_tensor_util.h - Tensor related utilities

   Copyright (c) 2024 Michal Babej / Intel Finland Oy

   Permission is hereby granted, free of charge, to any person obtaining a copy
   of this software and associated documentation files (the "Software"), to
   deal in the Software without restriction, including without limitation the
   rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
   sell copies of the Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.
*/

#include "pocl_cl.h"

int pocl_check_tensor_layout (cl_uint rank,
                              const cl_tensor_shape *shape,
                              cl_tensor_layout_type layout_type,
                              const void *layout);

int pocl_check_tensor_desc (const cl_tensor_desc *tdesc);

int pocl_copy_tensor_desc2mem (cl_mem mem, const cl_tensor_desc *tdesc);

int pocl_copy_tensor_desc_layout (cl_tensor_desc *dest,
                                  const cl_tensor_desc *src);

int pocl_tensor_type_is_int (cl_tensor_datatype T);

int pocl_tensor_type_size (cl_tensor_datatype T);

cl_bool pocl_tensor_dtype_value_equals (const cl_tensor_datatype DType,
                                        const cl_tensor_datatype_value *Value,
                                        cl_double doubleConst,
                                        cl_long longConst,
                                        cl_ulong ulongConst,
                                        char fp8Const,
                                        char int4Const);
